﻿// NOLINT: This file starts with a BOM since it contain non-ASCII characters
// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from rcss3d_agent_msgs:msg/Spherical.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "rcss3d_agent_msgs/msg/spherical.h"


#ifndef RCSS3D_AGENT_MSGS__MSG__DETAIL__SPHERICAL__STRUCT_H_
#define RCSS3D_AGENT_MSGS__MSG__DETAIL__SPHERICAL__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>

// Constants defined in the message

/// Struct defined in msg/Spherical in the package rcss3d_agent_msgs.
/**
  * Spherical msg used for soccer vision perceptors. All distances and angles are given
  * relative to the position and orientation of the camera.
  *
  * Details: https://gitlab.com/robocup-sim/SimSpark/-/wikis/Perceptors#vision-perceptors
  *
  * Angles are stored in degrees.
 */
typedef struct rcss3d_agent_msgs__msg__Spherical
{
  /// The distance to the seen object, in metres.
  float r;
  /// The horizontal angle (φ) to the visible object relative to the view direction in degrees
  /// and an accuracy of two digits. Positive angles are left of the vertical midline of the
  /// agent's vision, negative angles right.
  float phi;
  /// The vertical angle (θ) to the visible object relative to the view direction in degrees
  /// and an accuracy of two digits. Positive angles mean the seen object is above the
  /// horizontal midline of agent's vision, negative means below.
  float theta;
} rcss3d_agent_msgs__msg__Spherical;

// Struct for a sequence of rcss3d_agent_msgs__msg__Spherical.
typedef struct rcss3d_agent_msgs__msg__Spherical__Sequence
{
  rcss3d_agent_msgs__msg__Spherical * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} rcss3d_agent_msgs__msg__Spherical__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // RCSS3D_AGENT_MSGS__MSG__DETAIL__SPHERICAL__STRUCT_H_
